org.eclipse.microprofile.reactive.messaging.spi

## Annotation Type ConnectorAttribute

    @Retention(value=CLASS)
     @Target(value=TYPE)
     @Repeatable(value=ConnectorAttributes.class)
    public @interface ConnectorAttribute

Connector implementor can use this annotation to document attributes supported by their connector. This allows tools (IDE, annotation processors...) to extract that data to provide code completion or documentation generation. Each attribute is represented by an instance of `ConnectorAttribute`. For example:

      @ConnectorAttribute(name = "bootstrap.servers", alias = "kafka.bootstrap.servers", type = "string",
          defaultValue = "localhost:9092", direction = Direction.INCOMING_AND_OUTGOING,
          description = "...")
      @ConnectorAttribute(name = "topic", type = "string", direction = Direction.INCOMING_AND_OUTGOING,
          description = "...")
      @ConnectorAttribute(name = "value-deserialization-failure-handler", type = "string", direction = Direction.INCOMING,
          description = "...")
      @ConnectorAttribute(name = "merge", direction = OUTGOING, type = "boolean", defaultValue = "false",
          description = "...")
      @Connector("my-connector")
      public class MyConnector implements  IncomingConnectorFactory, OutgoingConnectorFactory {
        ...
     }

### Field Summary

Fields
`static String` `NO_VALUE` The constant used to indicate that the attribute has no default value or no alias.

### Required Element Summary

Required Elements
`String` `description`
`ConnectorAttribute.Direction` `direction`
`String` `name`
`String` `type`

### Optional Element Summary

Optional Elements
`String` `alias`
`String` `defaultValue`
`boolean` `deprecated`
`boolean` `hidden`
`boolean` `mandatory`

### Field Detail

#### NO_VALUE

    public static final String NO_VALUE

The constant used to indicate that the attribute has no default value or no alias.

### Element Detail

#### name

    public abstract String name

Returns:
  the attribute name, must not be `null`, must not be `blank`, must be unique for a specific connector

#### description

    public abstract String description

Returns:
  the description of the attribute.

#### direction

    public abstract ConnectorAttribute.Direction direction

Returns:
  on which direction the attribute is used.

#### type

    public abstract String type

Returns:
  the java type of the property.

#### hidden

    public abstract boolean hidden

Returns:
  whether the attribute must be hidden.

Default:
  false

#### mandatory

    public abstract boolean mandatory

Returns:
  whether the attribute is mandatory.

Default:
  false

#### defaultValue

    public abstract String defaultValue

Returns:
  the default value if any.

Default:
  "<no-value>"

#### deprecated

    public abstract boolean deprecated

Returns:
  whether the attribute is deprecated.

Default:
  false

#### alias

    public abstract String alias

Returns:
  the optional MicroProfile Config property used to configure the attribute.

Default:
  "<no-value>"